<template>
  <div class="page-folder">
    <section class="folder-show clearfix">
      <ProductFilterSearch v-if="totalresult" :total-result="totalresult" />
      <div v-if="totalresult" class="flex tab-default">
        <a
          href="javascript:;"
          :class="{ active: type_search == 'product' }"
          @click="changeTypeSeach('product')"
        >
          Sản phẩm
        </a>
        <!-- <a href="#">Hỏi -đáp</a> -->
        <a
          href="javascript:;"
          :class="{ active: type_search == 'article' }"
          @click="changeTypeSeach('article')"
        >
          Tin tức
        </a>
      </div>
      <div v-if="type_search == 'product'" class="flex mb56">
        <template v-if="products.data.length > 0">
          <ProductSidebarFilter
            :brands="brands"
            :list-filters="listFilters"
            :product_filters="product_filters"
            :option_filters="option_filters"
            :clear-filters="() => clearFilters()"
            :meta="products.meta"
          />
          <ProductList
            :products="products.data"
            :links="products.links"
            :meta="products.meta"
            :get-products="(page) => getProducts(page)"
          />
        </template>
        <SearchNull v-else></SearchNull>
      </div>
      <div v-else class="flex mb56 space-between">
        <Articles v-if="articles.data.length > 0" :articles="articles" />
        <SearchNull v-else></SearchNull>
      </div>
    </section>
  </div>
</template>

<script>
// import { EventBus } from '~/plugins/bus'
export default {
  name: 'ProductFolder',
  components: {
    ProductFilterSearch: () =>
      import('~/components/Products/Category/ProductFilterSearch'),
    ProductSidebarFilter: () =>
      import('~/components/Products/Category/ProductSidebarFilter'),
    ProductList: () => import('~/components/Products/Category/ProductList'),
    Articles: () => import('~/components/Search/Articles'),
    SearchNull: () => import('~/components/Search/SearchNull'),
  },
  async asyncData({ params, $axios, query }) {
    const search = query.search || ''
    const brands = await $axios.$get('/catalogue/brands')
    const listFilters = await $axios.$get('/catalogue/filters/list')
    const products = await $axios.$post('/catalogue/products/filter?page=1', {
      product_filters: {
        brands: [],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
      search,
    })
    const articles = await $axios.$post('/search/articles/list?page=1', {
      search,
    })

    return {
      brands: brands.data,
      listFilters,
      products,
      articles,
      search,
    }
  },
  data() {
    return {
      product_filters: {
        brands: [],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
      search: '',
      type_search: 'product',
      articles: {},
      totalresult: 0,
    }
  },
  watch: {
    product_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
    option_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
    '$route.query'(newVal, oldVal) {
      this.search = newVal.search
      this.getProducts(1)
      this.getArticles(1)
    },
  },
  created() {
    this.search = this.$route.query.search
    this.getProducts(1)
    this.getArticles(1)
  },
  mounted() {
    this.totalresult = this.products.meta.total + this.articles.meta.total
  },
  methods: {
    async getProducts(page) {
      const products = await this.$axios.$post(
        '/catalogue/products/filter?page=' + page,
        {
          product_filters: this.product_filters,
          option_filters: this.option_filters,
          search: this.search,
        }
      )
      this.products = products
      this.totalresult = this.products.meta.total + this.articles.meta.total
    },
    async getArticles(page) {
      const articles = await this.$axios.$post(
        '/search/articles/list?page=' + page,
        {
          search: this.search,
        }
      )
      this.articles = articles
      this.totalresult = this.products.meta.total + this.articles.meta.total
    },
    clearFilters() {
      this.product_filters = {
        brands: [],
        sub_brands: [],
      }
      this.option_filters = {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      }
    },
    changeTypeSeach(type) {
      this.type_search = type
    },
  },
  head() {
    return {
      title: 'Tìm kiếm | ThinkPro | Hệ thống bán lẻ máy tính nhập khẩu',
    }
  },
}
</script>
